## mingw-w64-tfel-4.2.1-1.src.tar.zst

=== CMakeLists.txt ===
# Remove when CMake >= 2.8.4 is required
set(CMAKE_LEGACY_CYGWIN_WIN32 0) 
cmake_minimum_required(VERSION 2.4)
cmake_policy(SET CMP0005 OLD)
cmake_policy(SET CMP0022 NEW)
if(CMAKE_VERSION VERSION_GREATER 3.0.0)
  cmake_policy(SET CMP0026 OLD)
endif(CMAKE_VERSION VERSION_GREATER 3.0.0)
if(CMAKE_VERSION VERSION_GREATER 3.1.0)
  cmake_policy(SET CMP0053 OLD)
  cmake_policy(SET CMP0054 NEW)
endif(CMAKE_VERSION VERSION_GREATER 3.1.0)
if(CMAKE_VERSION VERSION_GREATER 3.14.0)
  cmake_policy(SET CMP0083 NEW)  
  include(CheckPIESupported)
  check_pie_supported()
endif(CMAKE_VERSION VERSION_GREATER 3.14.0)

set(TFEL_VERSION_FLAVOUR "" CACHE STRING
  "Append a flavour to the version number")
option(TFEL_APPEND_VERSION
  "append TFEL version number to all libraries, executables and directories" OFF)
option(BUILD_SHARED_LIBS  "enable shared libraries" ON)
if(NOT BUILD_SHARED_LIBS)
  set(CMAKE_POSITION_INDEPENDENT_CODE ON)
  # when BUILD_SHARED_LIBS=OFF then disable option enable-static
  set(enable-static OFF CACHE BOOL "enable additional static libraries" FORCE)
endif()

if(EXISTS "${CMAKE_BINARY_DIR}/conanbuildinfo.cmake")
  include(${CMAKE_BINARY_DIR}/conanbuildinfo.cmake)
  conan_basic_setup(NO_OUTPUT_DIRS)
  set(TFEL_USES_CONAN ON)
endif(EXISTS "${CMAKE_BINARY_DIR}/conanbuildinfo.cmake")

set(CMAKE_CXX_STANDARD 17)
set(CXX_STANDARD_REQUIRED ON)

# tfel specific macros
include(cmake/modules/tfel.cmake)
# some variables for compatibility with autotools
include(cmake/modules/autotools.cmake)

#major and minor version
tfel_project(4 2 "1")
set(PACKAGE_BUGREPORT "tfel-contact@cea.fr")

# load the list of rounding modes defined by the IEEE754 standard
include(cmake/modules/ieee754.cmake)

# check for the fenv package
include(CheckIncludeFiles)
check_include_files(fenv.h HAVE_FENV_H)
if(HAVE_FENV_H)
  add_definitions("-DHAVE_FENV")
endif(HAVE_FENV_H)

option(enable-include-what-you-use
  "enable include-what-you-use diagnostics" OFF)
if(enable-include-what-you-use)
  find_program(TFEL_IWYU_PATH NAMES include-what-you-use iwyu)
  if(NOT TFEL_IWYU_PATH)
    message(FATAL_ERROR "could not find the program include-what-you-use")
  endif()
endif(enable-include-what-you-use)

find_package(Threads)

if(UNIX)
  if(NOT TFEL_DL_LIBRARY)
    # This is used in mtest tests files
    set(TFEL_LOCAL_LIBRARY_PREFIX "./")
    # Looking for libdl...
    if((${CMAKE_SYSTEM_NAME} MATCHES "Linux") OR
	(${CMAKE_SYSTEM_NAME} MATCHES "Darwin"))
      find_library(TFEL_DL_LIBRARY
	NAMES dl)
      if(NOT TFEL_DL_LIBRARY)
	MESSAGE(FATAL_ERROR "the libdl library not found. You may want to set the `TFEL_DL_LIBRARY` manually")
      endif(NOT TFEL_DL_LIBRARY)
    else((${CMAKE_SYSTEM_NAME} MATCHES "Linux") OR
	(${CMAKE_SYSTEM_NAME} MATCHES "Darwin"))
      set(TFEL_DL_LIBRARY "")
    endif((${CMAKE_SYSTEM_NAME} MATCHES "Linux") OR
      (${CMAKE_SYSTEM_NAME} MATCHES "Darwin"))
  endif(NOT TFEL_DL_LIBRARY)
else(UNIX)
  set(TFEL_LOCAL_LIBRARY_PREFIX "")
  set(TFEL_DL_LIBRARY "")
endif(UNIX)

# adding support for rpath on MacOs X
if(APPLE)
   set(CMAKE_MACOSX_RPATH ON)
   set(CMAKE_SKIP_BUILD_RPATH FALSE)
   set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
   set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
   set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
   list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib" isSystemDir)
   if("${isSystemDir}" STREQUAL "-1")
      set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
   endif()
endif()

# type of architecture
if( CMAKE_SIZEOF_VOID_P EQUAL 8 )
  add_definitions("-DTFEL_ARCH64")
else( CMAKE_SIZEOF_VOID_P EQUAL 8 )
  add_definitions("-DTFEL_ARCH32")
endif( CMAKE_SIZEOF_VOID_P EQUAL 8 )

#extraction git hash
if(NOT TFEL_GIT_HASH)
execute_process(
  COMMAND git log -1 --format=%h
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  OUTPUT_VARIABLE TFEL_GIT_HASH
  OUTPUT_STRIP_TRAILING_WHITESPACE)
message("Abbreviated commit hash: ${TFEL_GIT_HASH}")
endif(NOT TFEL_GIT_HASH)
add_definitions("-DTFEL_GIT_HASH=\\\"\"${TFEL_GIT_HASH}\"\\\"")
add_definitions("-DTFEL_CMAKE_GENERATOR=\\\"\"${CMAKE_GENERATOR}\"\\\"")

# testing
set(CTEST_CONFIGURATION_TYPE "${JOB_BUILD_CONFIGURATION}")
# (must be placed *before* any add_subdirectory, cmake bug ?)
option(enable-testing "enable tests" ON)
option(enable-mfront-quantity-tests "enable tests of behaviours using quantities (such tests fails on old compilers)" ON)
if(enable-testing)
  enable_testing()
  if(CMAKE_CONFIGURATION_TYPES)
    add_custom_target(check COMMAND
      ${CMAKE_CTEST_COMMAND} -T test -C $<CONFIGURATION>)
  else(CMAKE_CONFIGURATION_TYPES)
    add_custom_target(check COMMAND
      ${CMAKE_CTEST_COMMAND} -T test )
  endif(CMAKE_CONFIGURATION_TYPES)
endif()

option(enable-cppcheck "analyse targets with cppcheck" OFF)
if(enable-cppcheck)
  message(STATUS "cppcheck support enabled")
  set(HAVE_CPPCHECK ON)
  include(cmake/modules/FindCppCheck.cmake)
  include(cmake/modules/CppCheckTargets.cmake)
endif(enable-cppcheck)

option(enable-vera++ "analyse targets with vera++" OFF)
if(enable-vera++)
  message(STATUS "vera++ support enabled")
  find_package(vera++)
  include(${VERA++_USE_FILE})
  if(NOT VERA_ROOT)
    message(fatal "VERA_ROOT is not defined")
  endif(NOT VERA_ROOT)
  add_vera_targets(*.h *.cpp
    RECURSE
    ROOT "${VERA_ROOT}/lib/vera++")
endif(enable-vera++)

# floatting point exceptions (TODO)

# portable-build
option(enable-portable-build "produce binary that can be shared between various machine (same architecture, same gcc version, different processors" OFF)

# madnex
option(enable-madnex "enable madnex file support in mfront (see https://github.com/thelfer/madnex)" OFF)
if(enable-madnex)
  find_package(Madnex REQUIRED)
  set(TFEL_HAVE_MADNEX ON)
endif(enable-madnex)

# fortran (placed before compiler detection)
option(enable-fortran "enable fortran support" OFF)
if(enable-fortran)
  set(HAVE_FORTRAN ON)
  add_definitions("-DHAVE_FORTRAN=1")
  enable_language (Fortran)
  message(STATUS "fortran support enabled")
  set(enable-fortran-bindings ON)
else(enable-fortran)
  set(HAVE_FORTRAN OFF)
  message(STATUS "fortran support disabled")
  set(enable-fortran-bindings OFF)
endif(enable-fortran)

#compiler options
include(cmake/modules/compiler.cmake)
if(CMAKE_BUILD_TYPE STREQUAL "Coverage")
  include(cmake/modules/CodeCoverage.cmake)
  SETUP_TARGET_FOR_COVERAGE(coverage ctest coverage)
endif(CMAKE_BUILD_TYPE STREQUAL "Coverage")

#aster
option(enable-aster "build aster interface for mechanical behaviours" OFF)
if(enable-aster)
  message(STATUS "aster support enabled")
  set(HAVE_ASTER ON)
  add_definitions("-DHAVE_ASTER=1")
  include(cmake/modules/aster.cmake)
endif(enable-aster)

#abaqus
option(enable-abaqus "build abaqus interface for mechanical behaviours" OFF)
if(enable-abaqus)
  message(STATUS "abaqus support enabled")
  set(HAVE_ABAQUS ON)
  add_definitions("-DHAVE_ABAQUS=1")
endif(enable-abaqus)

# LS-DYNA
option(enable-lsdyna "build lsdyna interface for mechanical behaviours" OFF)
if(enable-lsdyna)
  message(STATUS "lsdyna support enabled")
  set(HAVE_LSDYNA ON)
  add_definitions("-DHAVE_LSDYNA=1")
endif(enable-lsdyna)

#diana-fea
option(enable-diana-fea "build Diana FEA interface for mechanical behaviours" OFF)
if(enable-diana-fea)
  message(STATUS "Diana FEA support enabled")
  set(HAVE_DIANAFEA ON)
  add_definitions("-DHAVE_DIANAFEA=1")
endif(enable-diana-fea)

#calculix
option(enable-calculix "build CalculiX interface for mechanical behaviours" OFF)
if(enable-calculix)
  message(STATUS "CalculiX support enabled")
  set(HAVE_CALCULIX ON)
  add_definitions("-DHAVE_CALCULIX=1")
endif(enable-calculix)

#ansys
option(enable-ansys "build ansys interface for mechanical behaviours" OFF)
if(enable-ansys)
  message(STATUS "ansys support enabled")
  set(HAVE_ANSYS ON)
  add_definitions("-DHAVE_ANSYS=1")
endif(enable-ansys)

#europlexus
option(enable-europlexus "build europlexus interface for mechanical behaviours" OFF)
if(enable-europlexus)
  message(STATUS "europlexus support enabled")
  set(HAVE_EUROPLEXUS ON)
  add_definitions("-DHAVE_EUROPLEXUS=1")
endif(enable-europlexus)

#zmat
option(enable-zmat "build zmat interface for mechanical behaviours" OFF)
if(enable-zmat)
  include(cmake/modules/zset.cmake)
  message(STATUS "zmat support enabled")
  set(HAVE_ZMAT ON)
  add_definitions("-DHAVE_ZMAT=1")
endif(enable-zmat)

#cyrano
include(cmake/modules/cyrano.cmake)
option(enable-cyrano "build cyrano interface for mechanical behaviours" OFF)
if(enable-cyrano)
  message(STATUS "cyrano support enabled")
  set(HAVE_CYRANO ON)
  add_definitions("-DHAVE_CYRANO=1")
endif(enable-cyrano)

#castem
include(cmake/modules/castem-unix-type.cmake)
option(local-castem-header    "use a local version of castem.h"  OFF)
option(enable-castem-pleiades "use a pleiades version of castem" OFF)
if(local-castem-header)
  add_definitions(-DLOCAL_CASTEM_HEADER=1)
  add_definitions("-DLOCAL_CASTEM_HEADER=1 -DHAVE_CASTEM=1")
  set(HAVE_CASTEM ON)
  set(LOCAL_CASTEM_HEADER ON)
else(local-castem-header)
  include(cmake/modules/castem.cmake)
endif(local-castem-header)

# comsol
option(enable-comsol "build Comsol interface for mechanical behaviours" OFF)
if(enable-comsol)
  message(STATUS "Comsol support enabled")
  set(HAVE_COMSOL ON)
  add_definitions("-DHAVE_COMSOL=1")
endif(enable-comsol)

#gnuplot
include(FindGnuplot)
if(GNUPLOT_FOUND)
  set(HAVE_GNUPLOT ON)
  add_definitions("-DHAVE_GNUPLOT=1")
  add_definitions("-DGNUPLOT_PATH=\\\"\"${GNUPLOT_EXECUTABLE}\"\\\"")
  message(STATUS "found gnuplot")
  message(STATUS "gnuplot path ${GNUPLOT_EXECUTABLE}")
else(GNUPLOT_FOUND)
  set(HAVE_GNUPLOT OFF)
endif(GNUPLOT_FOUND)

#python
option(enable-python "enable python support" OFF)
option(enable-python-bindings "enable  python bindings support" OFF)
option(enable-numpy-support
  "enable numpy support. This option has no effect if python bindings are disabled" ON)
option(enable-broken-boost-python-module-visibility-handling
  "workaround a bug in boost python which occurs on FreeBSD+clang. See https://github.com/boostorg/python/issues/173 for details" OFF)

option(python-static-interpreter-workaround
  "a workaround to handle the fact the conda' python interpreter is statically linked, which causes issues on Mac Os. See for details https://github.com/ContinuumIO/anaconda-issues/issues/9078. A proper solution may only appear with CMake 3.15 with the `Python::module` target, see https://gitlab.kitware.com/cmake/cmake/issues/18100. Until this version is widely available, this flag proposes a hack. Use with care." OFF)
 
if(enable-python OR enable-python-bindings)
  find_package(PythonLibs REQUIRED)
  set(HAVE_PYTHON ON)
  add_definitions("-DHAVE_PYTHON=1")
  add_definitions("-DTFEL_PYTHON_INCLUDES=\\\"\"-I${PYTHON_INCLUDE_DIRS}\"\\\"")
  get_filename_component(PYTHON_LIBRARY_PATH ${PYTHON_LIBRARIES} PATH)
  get_filename_component(PYTHON_LIBRARY_FULL ${PYTHON_LIBRARIES} NAME)
  string(REGEX REPLACE "lib(.+)\\.(.+)$" "\\1" PYTHON_LIBRARY ${PYTHON_LIBRARY_FULL})
  add_definitions("-DTFEL_PYTHON_LIBRARY_PATH=\\\"\"${PYTHON_LIBRARY_PATH}\"\\\"")
  add_definitions("-DTFEL_PYTHON_LIBRARY=\\\"\"${PYTHON_LIBRARY}\"\\\"")
  if(MSVC)
    add_definitions("-DTFEL_PYTHON_LIBS=\\\"\"${PYTHON_LIBRARY_PATH}\${PYTHON_LIBRARY}\"\\\"")
  else(MSVC)
    add_definitions("-DTFEL_PYTHON_LIBS=\\\"\"-L${PYTHON_LIBRARY_PATH} -l${PYTHON_LIBRARY}\"\\\"")
  endif(MSVC) 
  message(STATUS "found python          ${PYTHONLIBS_VERSION_STRING}")
  message(STATUS "python include path   ${PYTHON_INCLUDE_DIRS}")
  message(STATUS "python libraries path ${PYTHON_LIBRARY_PATH}")
  message(STATUS "python library        ${PYTHON_LIBRARY}")
  string(REGEX REPLACE "[a-z]+.*$" "" PYTHONLIBS_VERSION_CLEANED "${PYTHONLIBS_VERSION_STRING}")
  find_package(PythonInterp ${PYTHONLIBS_VERSION_CLEANED} REQUIRED)
  message(STATUS "python interpreter    ${PYTHON_EXECUTABLE}")
  if(NOT TFEL_PYTHON_SITE_PACKAGES_DIR)
    if(WIN32)

=== docs/CMakeLists.txt ===
if(GENERATE_DOXYGEN)
  add_subdirectory(doxygen)
endif(GENERATE_DOXYGEN)

if(GENERATE_REFERENCE_DOC)
  add_subdirectory(tfel)
  add_subdirectory(release-notes-2.0)
  add_subdirectory(release-notes-2.0.3)
  add_subdirectory(release-notes-2.0.4)
  add_subdirectory(release-notes-3.0)
  add_subdirectory(tutorial)
  add_subdirectory(presentations)
endif(GENERATE_REFERENCE_DOC)

if(GENERATE_WEBSITE)
  add_subdirectory(web)
endif(GENERATE_WEBSITE)

add_subdirectory(gallery)
add_subdirectory(mfront)
add_subdirectory(mtest)
add_subdirectory(ptest)

=== include/CMakeLists.txt ===
install_header(TFEL Macros.hxx)
install_header(TFEL ContractViolation.hxx)
install_header(TFEL Raise.hxx)
install_header(TFEL Raise.ixx)
install_header(TFEL PhysicalConstants.hxx)

install_header(TFEL/Config/Internals TFELTypesInternals.hxx)
install_header(TFEL/Config/Internals SpatialGradType.hxx)
install_header(TFEL/Config/Internals TemperatureGradientType.hxx)
install_header(TFEL/Config/Internals HeatFluxVectorType.hxx)
install_header(TFEL/Config/Internals InvJacobianType.hxx)
install_header(TFEL/Config/Internals PositionType.hxx)
install_header(TFEL/Config/Internals JacobianType.hxx)
install_header(TFEL/Config/Internals ThermalConductivityMatrixType.hxx)
install_header(TFEL/Config TFEL_MATH_Config.hxx)
install_header(TFEL/Config TFELTypes.hxx)
install_header(TFEL/Config TFELConfig.hxx)
install_header(TFEL/Config GetInstallPath.hxx)
install_header(TFEL/Config GetTFELVersion.h)

install_header(TFEL/Glossary/Forward Glossary.hxx)
install_header(TFEL/Glossary Glossary.hxx)
install_header(TFEL/Glossary GlossaryEntry.hxx)

install_header(TFEL/UnicodeSupport UnicodeSupport.hxx)

install_header(TFEL/Metaprogramming/Forward TypeList.hxx)
install_header(TFEL/Metaprogramming Implements.hxx)
install_header(TFEL/Metaprogramming TypeList.hxx)
install_header(TFEL/Metaprogramming TypeList.ixx)
install_header(TFEL/Metaprogramming IsConstCallable.hxx)
install_header(TFEL/Metaprogramming GenerateTypeList.hxx)
install_header(TFEL/Metaprogramming InvalidType.hxx)
install_header(TFEL/Metaprogramming HasIterator.hxx)
install_header(TFEL/Metaprogramming HasConstIterator.hxx)
install_header(TFEL/Metaprogramming HasRandomAccessConstIterator.hxx)
install_header(TFEL/Metaprogramming EmptyClass.hxx)
install_header(TFEL/Metaprogramming HasRandomAccessIterator.hxx)
install_header(TFEL/Metaprogramming ResultOf.hxx)
install_header(TFEL/Metaprogramming MakeIntegerRange.hxx)

install_header(TFEL/TypeTraits/Promote Promote.ixx)
install_header(TFEL/TypeTraits BaseType.hxx)
install_header(TFEL/TypeTraits AbsType.hxx)
install_header(TFEL/TypeTraits RealPartType.hxx)
install_header(TFEL/TypeTraits IsFundamentalNumericType.hxx)
install_header(TFEL/TypeTraits IsReal.hxx)
install_header(TFEL/TypeTraits IsScalar.hxx)
install_header(TFEL/TypeTraits IsComplex.hxx)
install_header(TFEL/TypeTraits Promote.hxx)
install_header(TFEL/TypeTraits IsAssignableTo.hxx)
install_header(TFEL/TypeTraits IsUnaryOperator.hxx)
install_header(TFEL/TypeTraits IsInvalid.hxx)
install_header(TFEL/TypeTraits IsRandomAccessIterator.hxx)

install_header(TFEL/System RecursiveFind.hxx)
install_header(TFEL/System ExternalMaterialKnowledgeDescription.hxx)
install_header(TFEL/System ExternalMaterialPropertyDescription.hxx)
install_header(TFEL/System ExternalBehaviourDescription.hxx)
install_header(TFEL/System ExternalFunctionsPrototypes.hxx)
install_header(TFEL/System ExternalLibraryManager.hxx)
install_header(TFEL/System ProcessManager.h)
install_header(TFEL/System ProcessManager.hxx)
install_header(TFEL/System SignalHandler.ixx)
install_header(TFEL/System SystemError.hxx)
install_header(TFEL/System System.hxx)
install_header(TFEL/System SignalHandler.hxx)
install_header(TFEL/System SignalManager.hxx)
install_header(TFEL/System SystemError.ixx)
install_header(TFEL/System ChildProcess.hxx)
install_header(TFEL/System BinaryRead.hxx)
install_header(TFEL/System BinaryWrite.hxx)
install_header(TFEL/System STLContainerBinaryRead.hxx)
install_header(TFEL/System STLContainerBinaryWrite.hxx)
install_header(TFEL/System stream_traits.hxx)
install_header(TFEL/System basic_rstream.hxx)
install_header(TFEL/System basic_rstream.ixx)
install_header(TFEL/System basic_wstream.hxx)
install_header(TFEL/System basic_wstream.ixx)
install_header(TFEL/System rstreamView.hxx)
install_header(TFEL/System rstreamView.ixx)
install_header(TFEL/System wstreamView.hxx)
install_header(TFEL/System wstreamView.ixx)
install_header(TFEL/System rfstream.hxx)
install_header(TFEL/System wfstream.hxx)
install_header(TFEL/System getFunction.h)
install_header(TFEL/System ThreadPool.hxx)
install_header(TFEL/System ThreadPool.ixx)
install_header(TFEL/System ThreadedTaskResult.hxx)
install_header(TFEL/System ThreadedTaskResult.ixx)
install_header(TFEL/System LibraryInformation.hxx)

install_header(TFEL/Utilities StringAlgorithms.hxx)
install_header(TFEL/Utilities Argument.hxx)
install_header(TFEL/Utilities ArgumentParser.hxx)
install_header(TFEL/Utilities ArgumentParserBase.hxx)
install_header(TFEL/Utilities ArgumentParserBase.ixx)
install_header(TFEL/Utilities CxxKeywords.hxx)
install_header(TFEL/Utilities CxxTokenizerOptions.hxx)
install_header(TFEL/Utilities CxxTokenizer.hxx)
install_header(TFEL/Utilities CxxTokenizer.ixx)
install_header(TFEL/Utilities Token.hxx)
install_header(TFEL/Utilities Data.hxx)
install_header(TFEL/Utilities Data.ixx)
install_header(TFEL/Utilities TerminalColors.hxx)
install_header(TFEL/Utilities GenTypeCastError.hxx)
install_header(TFEL/Utilities GenTypeBase.hxx)
install_header(TFEL/Utilities GenTypeBase.ixx)
install_header(TFEL/Utilities GenTypeSpecialisation.ixx)
install_header(TFEL/Utilities TextData.hxx)
install_header(TFEL/Utilities FCString.hxx)
install_header(TFEL/Utilities FCString.ixx)

install_header(TFEL/Exception TFELException.hxx)

install_header(TFEL/FSAlgorithm loop.hxx)
install_header(TFEL/FSAlgorithm swap_ranges.hxx)
install_header(TFEL/FSAlgorithm copy.hxx)
install_header(TFEL/FSAlgorithm generate.hxx)
install_header(TFEL/FSAlgorithm inner_product.hxx)
install_header(TFEL/FSAlgorithm transform.hxx)
install_header(TFEL/FSAlgorithm iota.hxx)
install_header(TFEL/FSAlgorithm min_element.hxx)
install_header(TFEL/FSAlgorithm max_element.hxx)
install_header(TFEL/FSAlgorithm FSAlgorithm.hxx)
install_header(TFEL/FSAlgorithm accumulate.hxx)
install_header(TFEL/FSAlgorithm fill.hxx)
install_header(TFEL/FSAlgorithm for_each.hxx)
install_header(TFEL/FSAlgorithm equal.hxx)

install_header(TFEL/Math/Forward vector.hxx)
install_header(TFEL/Math/Forward qt.hxx)
install_header(TFEL/Math/Forward Complex.hxx)
install_header(TFEL/Math/Forward fsarray.hxx)
install_header(TFEL/Math/Forward runtime_array.hxx)
install_header(TFEL/Math/Forward tvector.hxx)
install_header(TFEL/Math/Forward tmatrix.hxx)
install_header(TFEL/Math/Forward matrix.hxx)
install_header(TFEL/Math/Forward tensor.hxx)
install_header(TFEL/Math/Forward stensor.hxx)
install_header(TFEL/Math/Forward t2tot2.hxx)
install_header(TFEL/Math/Forward t2tost2.hxx)
install_header(TFEL/Math/Forward st2tot2.hxx)
install_header(TFEL/Math/Forward st2tost2.hxx)
install_header(TFEL/Math/Forward Expr.hxx)

install_header(TFEL/Math/Bindings atlas.hxx)
install_header(TFEL/Math fsarray.hxx)
install_header(TFEL/Math runtime_array.hxx)
install_header(TFEL/Math power.hxx)
install_header(TFEL/Math power.ixx)
install_header(TFEL/Math Discretization1D.hxx)
install_header(TFEL/Math Discretization1D.ixx)
install_header(TFEL/Math/Array ArrayConcept.hxx)
install_header(TFEL/Math/Array fsarrayIO.hxx)
install_header(TFEL/Math/Array runtime_arrayIO.hxx)
install_header(TFEL/Math/Array StandardTemplateLibraryCompatibilityLayers.hxx)
install_header(TFEL/Math/Array StandardTemplateLibraryCompatibilityLayers.ixx)
install_header(TFEL/Math/Array ArrayCommonMethods.hxx)
install_header(TFEL/Math/Array ArrayCommonMethods.ixx)
install_header(TFEL/Math/Array ArrayPolicies.hxx)
install_header(TFEL/Math/Array ArrayPolicies.ixx)
install_header(TFEL/Math/Array ConstFixedSizeArrayBase.hxx)
install_header(TFEL/Math/Array ConstFixedSizeArrayBase.ixx)
install_header(TFEL/Math/Array ConstRuntimeArrayBase.hxx)
install_header(TFEL/Math/Array ConstRuntimeArrayBase.ixx)
install_header(TFEL/Math/Array View.hxx)
install_header(TFEL/Math/Array ViewsArray.hxx)
install_header(TFEL/Math/Array ViewsArrayIO.hxx)
install_header(TFEL/Math/Array FixedSizeArrayPolicies.hxx)
install_header(TFEL/Math/Array FixedSizeIndexingPolicies.hxx)
install_header(TFEL/Math/Array GenericFixedSizeArray.hxx)
install_header(TFEL/Math/Array GenericFixedSizeArray.ixx)
install_header(TFEL/Math/Array GenericRuntimeArray.hxx)
install_header(TFEL/Math/Array GenericRuntimeArray.ixx)
install_header(TFEL/Math/Array IndexingPolicies.hxx)
install_header(TFEL/Math/Array IndexingPolicies.ixx)
install_header(TFEL/Math/Array IterateOverMultipleIndices.hxx)
install_header(TFEL/Math/Array MultipleIndicesFunctors.hxx)
install_header(TFEL/Math/Array MutableFixedSizeArrayBase.hxx)
install_header(TFEL/Math/Array MutableFixedSizeArrayBase.ixx)
install_header(TFEL/Math/Array MutableRuntimeArrayBase.hxx)
install_header(TFEL/Math/Array MutableRuntimeArrayBase.ixx)
install_header(TFEL/Math/Array RuntimeArrayPolicies.hxx)
install_header(TFEL/Math/Array RuntimeIndexingPolicies.hxx)
install_header(TFEL/Math/Array FixedSizeArrayDerivative.hxx)
install_header(TFEL/Math/Parser BinaryFunction.hxx)
install_header(TFEL/Math/Parser EvaluatorBase.hxx)
install_header(TFEL/Math/Parser Negation.hxx)
install_header(TFEL/Math/Parser BinaryFunction.ixx)
install_header(TFEL/Math/Parser Expr.hxx)
install_header(TFEL/Math/Parser Number.hxx)
install_header(TFEL/Math/Parser BinaryOperator.hxx)
install_header(TFEL/Math/Parser BinaryOperator.ixx)
install_header(TFEL/Math/Parser Function.hxx)
install_header(TFEL/Math/Parser Function.ixx)
install_header(TFEL/Math/Parser PowerFunction.hxx)
install_header(TFEL/Math/Parser PowerFunction.ixx)
install_header(TFEL/Math/Parser Variable.hxx)
install_header(TFEL/Math/Parser ExternalCFunction.hxx)
install_header(TFEL/Math/Parser ExternalCastemFunction.hxx)
install_header(TFEL/Math/Parser ExternalCyranoFunction.hxx)
install_header(TFEL/Math/Parser ExternalFunction.hxx)
install_header(TFEL/Math/Parser ConstantExternalFunction.hxx)
install_header(TFEL/Math/Parser ExternalFunctionManager.hxx)
install_header(TFEL/Math/Parser ExternalFunctionExpr.hxx)
install_header(TFEL/Math/Parser ExternalFunctionExpr2.hxx)
install_header(TFEL/Math/Parser DifferentiatedFunctionExpr.hxx)
install_header(TFEL/Math/Parser KrigedFunction.hxx)
install_header(TFEL/Math/Parser KrigedFunction.ixx)
install_header(TFEL/Math/Parser EvaluatorTExpr.hxx)
install_header(TFEL/Math/Parser EvaluatorTExpr.ixx)
install_header(TFEL/Math/Parser IntegerEvaluatorTExpr.hxx)
install_header(TFEL/Math/Parser EvaluatorProxy.hxx)
install_header(TFEL/Math/Parser EvaluatorProxy.ixx)
install_header(TFEL/Math/Parser LogicalExpr.hxx)
install_header(TFEL/Math/Parser LogicalExpr.ixx)
install_header(TFEL/Math/Parser ConditionalExpr.hxx)
install_header(TFEL/Math/Parser EvaluatorFunction.hxx)
install_header(TFEL/Math/Parser EvaluatorFunction.ixx)
install_header(TFEL/Math/Parser LevenbergMarquardtEvaluatorWrapper.hxx)
install_header(TFEL/Math/Parser LevenbergMarquardtExternalFunctionWrapper.hxx)
install_header(TFEL/Math Evaluator.hxx)
install_header(TFEL/Math IntegerEvaluator.hxx)
install_header(TFEL/Math Kriging.hxx)
install_header(TFEL/Math Kriging1D.hxx)
install_header(TFEL/Math Kriging2D.hxx)
install_header(TFEL/Math Kriging3D.hxx)
install_header(TFEL/Math FactorizedKriging.hxx)
install_header(TFEL/Math FactorizedKriging1D1D.hxx)
install_header(TFEL/Math FactorizedKriging1D2D.hxx)
install_header(TFEL/Math FactorizedKriging1D3D.hxx)
install_header(TFEL/Math LinearInterpolation.hxx)
install_header(TFEL/Math LinearInterpolation.ixx)
install_header(TFEL/Math CubicSpline.hxx)
install_header(TFEL/Math CubicSpline.ixx)
install_header(TFEL/Math/Kriging Kriging.ixx)
install_header(TFEL/Math/Kriging KrigingUtilities.hxx)
install_header(TFEL/Math/Kriging KrigingPieceWiseLinearModel1D.hxx)
install_header(TFEL/Math/Kriging KrigingDefaultModel1D.hxx)
install_header(TFEL/Math/Kriging KrigingErrors.hxx)
install_header(TFEL/Math/Kriging KrigingDefaultNuggetModel.hxx)
install_header(TFEL/Math/Kriging FactorizedKriging.ixx)
install_header(TFEL/Math/Kriging KrigingVariable.hxx)
install_header(TFEL/Math/Kriging KrigingDefaultModel3D.hxx)
install_header(TFEL/Math/Kriging KrigingDefaultModels.hxx)
install_header(TFEL/Math/Kriging KrigingDefaultModel2D.hxx)

=== mfront-query/CMakeLists.txt ===
add_subdirectory(include)
add_subdirectory(src)
if(enable-testing)
  add_subdirectory(tests)
endif()

=== bindings/fortran77/CMakeLists.txt ===
if(TFEL_APPEND_SUFFIX)  
  install(FILES TFELPHYSICALCONSTANTS.INC
    DESTINATION "include/TFEL-${TFEL_SUFFIX}/TFEL/"
    COMPONENT core)
else(TFEL_APPEND_SUFFIX)
  install(FILES TFELPHYSICALCONSTANTS.INC
    DESTINATION "include/TFEL/"
    COMPONENT core)
endif(TFEL_APPEND_SUFFIX)

=== docs/gallery/CMakeLists.txt ===
add_subdirectory(behaviours)

=== docs/presentations/CMakeLists.txt ===
add_subdirectory(mfront-behaviours)
add_subdirectory(mfront-finitestrain)
add_subdirectory(mfront-formation)
add_subdirectory(mfront-formation-tp)
add_subdirectory(mfront-presentation)
add_subdirectory(mtest-presentation)

if(HAVE_PANDOC)
  add_subdirectory(portable-behaviour)
endif(HAVE_PANDOC)

=== docs/release-notes-2.0/CMakeLists.txt ===
if(HAVE_LATEX)
  configure_file(Champs.tex.in Champs.tex @ONLY)
  configure_file(tfel-2.0.tex.in
    tfel-2.0.tex @ONLY)

  ADD_CUSTOM_COMMAND(
    OUTPUT    tfel-2.0.pdf
    DEPENDS    ${CMAKE_CURRENT_SOURCE_DIR}/Champs.tex.in
    DEPENDS    ${CMAKE_CURRENT_SOURCE_DIR}/tfel-2.0.tex.in
    COMMAND   TEXMFHOME=@abs_top_srcdir@/docs/tex/texmf        ${LATEX_COMPILER}
    ARGS      -interaction=batchmode tfel-2.0.tex
    COMMAND   TEXMFHOME=@abs_top_srcdir@/docs/tex/texmf        ${LATEX_COMPILER}
    ARGS      -interaction=batchmode tfel-2.0.tex
    COMMAND   BSTINPUTS=@abs_top_srcdir@/docs/tex/texmf/bibtex ${BIBTEX_COMPILER}
    ARGS      -terse tfel-2.0
    # COMMAND   ${MAKEINDEX_COMPILER}
    # ARGS      -s ${CMAKE_CURRENT_SOURCE_DIR}/style.ist mkeys.idx
    COMMAND   TEXMFHOME=@abs_top_srcdir@/docs/tex/texmf        ${LATEX_COMPILER}
    ARGS      -interaction=batchmode tfel-2.0.tex
    COMMAND   TEXMFHOME=@abs_top_srcdir@/docs/tex/texmf        ${LATEX_COMPILER}
    ARGS      -interaction=batchmode tfel-2.0.tex
    COMMAND   TEXMFHOME=@abs_top_srcdir@/docs/tex/texmf        ${DVIPS_CONVERTER}
    ARGS      -R0 tfel-2.0.dvi
    COMMAND   ${PS2PDF_CONVERTER}
    ARGS      tfel-2.0.ps
    COMMENT   "tfel-2.0.pdf")

  add_custom_target(tfel-2.0-doc-pdf ALL DEPENDS tfel-2.0.pdf)
  add_dependencies(doc-pdf
    tfel-2.0-doc-pdf)
  if(TFEL_APPEND_SUFFIX)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/tfel-2.0.pdf
      DESTINATION share/doc/tfel-${TFEL_SUFFIX}/references
      COMPONENT docs)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/tfel-2.0.pdf
      DESTINATION share/doc/tfel-${TFEL_SUFFIX}/web/documents/tfel
      COMPONENT website)
  else(TFEL_APPEND_SUFFIX)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/tfel-2.0.pdf
      DESTINATION share/doc/tfel/references
      COMPONENT docs)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/tfel-2.0.pdf
      DESTINATION share/doc/tfel/web/documents/tfel
      COMPONENT website)
  endif(TFEL_APPEND_SUFFIX)

endif(HAVE_LATEX)

=== docs/web/CMakeLists.txt ===
macro(pandoc_html file)
  ADD_CUSTOM_COMMAND(
    OUTPUT    ${CMAKE_CURRENT_BINARY_DIR}/${file}.html
    DEPENDS   ${CMAKE_CURRENT_SOURCE_DIR}/${file}.md
    DEPENDS   ${CMAKE_CURRENT_SOURCE_DIR}/mfront-template.html
    DEPENDS   ${CMAKE_CURRENT_SOURCE_DIR}/css/main.css
    COMMAND   ${PANDOC}
    ARGS      -f markdown-markdown_in_html_blocks+tex_math_single_backslash+grid_tables
    ARGS      --filter pandoc-crossref -M crossrefYaml=${CMAKE_CURRENT_SOURCE_DIR}/pandoc-crossref.yaml
    ARGS      --bibliography=${CMAKE_CURRENT_SOURCE_DIR}/bibliography.bib --citeproc
    ARGS      --template=${CMAKE_CURRENT_SOURCE_DIR}/mfront-template.html
    ARGS      --csl=${CMAKE_CURRENT_SOURCE_DIR}/iso690-numeric-en.csl
    ARGS      --mathjax
    ARGS      --highlight-style=tango
    ARGS      --email-obfuscation=javascript
    ARGS       --default-image-extension=svg
    ARGS      ${ARGN}
    ARGS      ${CMAKE_CURRENT_SOURCE_DIR}/${file}.md -o ${file}.html)
  add_custom_target(${file}-html ALL DEPENDS ${file}.html)
  add_dependencies(website ${file}-html)
  if(TFEL_APPEND_SUFFIX)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${file}.html
      DESTINATION share/doc/tfel-${TFEL_SUFFIX}/web
      COMPONENT website)
  else(TFEL_APPEND_SUFFIX)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${file}.html
      DESTINATION share/doc/tfel/web
      COMPONENT website)
  endif(TFEL_APPEND_SUFFIX)
endmacro(pandoc_html)

add_custom_target(website)
add_dependencies(doc website)

pandoc_html(index "-c css/slideshow.css")
pandoc_html(initializers)
pandoc_html(post-processings)
pandoc_html(associated-projects "--toc")
pandoc_html(mfront-types "--toc")
pandoc_html(search)
pandoc_html(faq "--toc")
pandoc_html(getting-started "--toc")
pandoc_html(interfaces)
pandoc_html(install "--toc" "--number-sections")
pandoc_html(install-freebsd "-c css/slideshow.css")
pandoc_html(install-windows-msys)
pandoc_html(install-windows-Cast3M2017 "--toc")
pandoc_html(install-windows-VisualStudio)
pandoc_html(packages)
pandoc_html(about)
pandoc_html(svn)
pandoc_html(devel)
pandoc_html(mtest)
pandoc_html(mtest-python "--toc" "--toc-depth=3")
pandoc_html(tutorial "--toc" "--toc-depth=3")
pandoc_html(tutorial-spanish  "--toc" "--toc-depth=3")
pandoc_html(benchmark)
pandoc_html(news "-c css/slideshow.css")
pandoc_html(castem)
pandoc_html(castem-fr)
pandoc_html(amitex "-c css/slideshow.css")
pandoc_html(cyrano "--toc" "--toc-depth=1"  "--number-sections")
pandoc_html(aster "--toc" "--toc-depth=1"  "-c css/slideshow.css")
pandoc_html(abaqus "-c css/slideshow.css")
pandoc_html(ansys "-c css/slideshow.css")
pandoc_html(calculix "-c css/slideshow.css")
pandoc_html(zmat)
pandoc_html(epx "-c css/slideshow.css")
pandoc_html(documentations)
pandoc_html(gallery  "--toc")
pandoc_html(glossary)
pandoc_html(material-properties "--toc" "--toc-depth=3" "--number-sections")
pandoc_html(behaviours)
pandoc_html(implicit-dsl "--toc" "--toc-depth=3"  "--number-sections")
pandoc_html(models)
pandoc_html(parameters "--toc" "--toc-depth=3"  "--number-sections")
pandoc_html(publications)
pandoc_html(release-notes "--toc" "--toc-depth=1")
pandoc_html(mfront-query "--toc" "--toc-depth=2")
pandoc_html(compiling-mfront-shared-libraries "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(madnex "--toc" "--toc-depth=2")
pandoc_html(math "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(mfm)
pandoc_html(mfm-test-generator)
pandoc_html(mfront-doc)
pandoc_html(tfel-material "--toc" "--toc-depth=2")
pandoc_html(tfel-math "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(tfel-math-data-interpolation "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(tfel-check "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(mfront-python "--toc" "--toc-depth=3")
pandoc_html(Norton-web)
pandoc_html(Norton-full)
pandoc_html(coverity-scan)
pandoc_html(drucker "--toc")
pandoc_html(drucker-prager-cap "--toc")
pandoc_html(hosford "--toc")
pandoc_html(barlat-yld2004 "--toc")
pandoc_html(greenplasticity "--toc")
pandoc_html(hyperelasticity "--toc")
pandoc_html(FeFpImplicitPlasticity "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(signorini "--toc" "--toc-depth=2" "-c css/slideshow.css")
pandoc_html(ogden "--toc" "--toc-depth=2")
pandoc_html(iwan "--toc" "--toc-depth=2")
pandoc_html(hyperviscoelasticity "--toc" "--toc-depth=2")
pandoc_html(IsotropicLinearHardeningPlasticity "--toc" "--toc-depth=2")
pandoc_html(orthotropiclinearhardeningplasticity "--toc" "--toc-depth=2")
pandoc_html(physical-constants)
pandoc_html(isotropicplasticityamstrongfrederickinematichardening "--toc" "--toc-depth=2")
pandoc_html(singlecrystal "--toc" "--toc-depth=2")
pandoc_html(finitestrainsinglecrystal "--toc" "--toc-depth=2")
pandoc_html(finitestrainsinglecrystal-huang "--toc" "--toc-depth=2")
pandoc_html(phasefield "--toc" "--toc-depth=2")
pandoc_html(release-notes-2.0.5 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0   "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0.1 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0.2 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0.3 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0.4 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0.5 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0.6 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0.7 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0.8 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0.9 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0.10 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0.11 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0.12 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.1   "--toc" "--toc-depth=2" "--number-sections" "-c css/slideshow.css")
pandoc_html(release-notes-3.1.1 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.1.2 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.1.3 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.1.4 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.1.5 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.1.6 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.1.7 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.1.8 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.1.9 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.1.10 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.1.11 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.1.12 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.2   "--toc" "--toc-depth=2" "--number-sections" "-c css/slideshow.css")
pandoc_html(release-notes-3.2.1 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.2.2 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.2.3 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.2.3 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.2.4 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.2.5 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.2.6 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.2.7 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.2.8 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.2.9 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.3   "--toc" "--toc-depth=2" "--number-sections" "-c css/slideshow.css")
pandoc_html(release-notes-3.3.1   "--toc" "--toc-depth=2" "--number-sections" "-c css/slideshow.css")
pandoc_html(release-notes-3.3.2   "--toc" "--toc-depth=2" "--number-sections" "-c css/slideshow.css")
pandoc_html(release-notes-3.3.3)
pandoc_html(release-notes-3.3.4   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-3.4   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-3.4.1   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-3.4.2   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-3.4.3   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-3.4.4   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-3.4.5   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-4.0   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-4.0.1 "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-4.0.2 "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-4.1   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-4.1.1 "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-4.2   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(theory  "--toc" "--toc-depth=2")
pandoc_html(tensors "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(tfel-physical-constants "--toc" "--toc-depth=2")
pandoc_html(tfel-python "--toc" "--toc-depth=3")
pandoc_html(generic-material-property-interface "--toc")
pandoc_html(generic-behaviours-interface "--toc" "--toc-depth=3")
pandoc_html(sovs "--toc" "--toc-depth=2")
pandoc_html(unicode "--toc" "--toc-depth=2")
pandoc_html(RambergOsgoodNonLinearElasticity "--toc" "--toc-depth=2")
pandoc_html(MericCailletaudSingleCrystalPlasticity  "--toc" "--toc-depth=2")
pandoc_html(MohrCoulomb "--toc" "--toc-depth=2")
pandoc_html(FichantLaBorderieDamageBehaviour "--toc" "--toc-depth=2")
pandoc_html(LoadInducedThermalStrainBehaviourTorelli2018  "--toc" "--toc-depth=2")
pandoc_html(FichantLaBorderieDamageAndTorelliLoadInducedStrainBehaviour   "--toc" "--toc-depth=2")
pandoc_html(FischerBurmeister "--toc" "--toc-depth=2")
pandoc_html(TFELSystem "--toc" "--toc-depth=2")
pandoc_html(BehaviourBricks "--toc" "--toc-depth=2")
pandoc_html(DDIF2Brick "--toc" "--toc-depth=2")
pandoc_html(StandardElastoViscoPlasticityBrick "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(StandardElastoViscoPlasticityBrick-PorousPlasticity "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(ExtendingStandardElastoViscoPlasticityBrick-StressCriterion "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(ExtendingStandardElastoViscoPlasticityBrick-PorousStressCriterion "--toc" "--toc-depth=2"  "--number-sections")
pandoc_html(HookeStressPotential "--toc" "--toc-depth=2")
pandoc_html(DDIF2StressPotential "--toc" "--toc-depth=2")
pandoc_html(ExplicitBerveillerZaouiPolyCrystals "--toc" "--toc-depth=2")
pandoc_html(ImplicitBerveillerZaouiPolyCrystals "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(Burger_EDF_CIWAP_2021 "--toc" "--toc-depth=2")

# mfront keywords

pandoc_html(DefaultDSL-keywords "--toc" "--toc-depth=1")
pandoc_html(DefaultFiniteStrainDSL-keywords "--toc" "--toc-depth=1")
pandoc_html(DefaultCZMDSL-keywords "--toc" "--toc-depth=1")
pandoc_html(Implicit-keywords "--toc" "--toc-depth=1")
pandoc_html(ImplicitFiniteStrain-keywords "--toc" "--toc-depth=1")
pandoc_html(ImplicitII-keywords "--toc" "--toc-depth=1")
pandoc_html(IsotropicMisesCreep-keywords "--toc" "--toc-depth=1")
pandoc_html(IsotropicPlasticMisesFlow-keywords "--toc" "--toc-depth=1")
pandoc_html(IsotropicStrainHardeningMisesCreep-keywords "--toc" "--toc-depth=1")
pandoc_html(MaterialLaw-keywords "--toc" "--toc-depth=1")
pandoc_html(Model-keywords "--toc" "--toc-depth=1")
pandoc_html(MultipleIsotropicMisesFlows-keywords "--toc" "--toc-depth=1")
pandoc_html(RungeKutta-keywords "--toc" "--toc-depth=1")

# mtest keywords

pandoc_html(MTest-keywords "--toc" "--toc-depth=1")

if(TFEL_APPEND_SUFFIX)
  install(DIRECTORY js css doc img media downloads cxx mfront scripts
    DESTINATION share/doc/tfel-${TFEL_SUFFIX}/web
    COMPONENT website
    PATTERN ".svn" EXCLUDE)
  install(FILES 404.html apple-touch-icon-precomposed.png 
    CHANGELOG.md CONTRIBUTING.md crossdomain.xml favicon.ico
    humans.txt LICENSE.md README.md robots.txt TODO.md
    DESTINATION share/doc/tfel-${TFEL_SUFFIX}/web
    COMPONENT website)
else(TFEL_APPEND_SUFFIX)
  install(DIRECTORY js css doc img media downloads cxx mfront scripts
    DESTINATION share/doc/tfel/web
    COMPONENT website
    PATTERN ".svn" EXCLUDE)
  install(FILES 404.html apple-touch-icon-precomposed.png 
    CHANGELOG.md CONTRIBUTING.md crossdomain.xml favicon.ico

=== mfm-test-generator/src/CMakeLists.txt ===
macro(mfmtg_library name)
  tfel_library_internal(${name} mfm ${ARGN})
endmacro(mfmtg_library)

mfmtg_library(MFMTestGenerator
  Log.cxx
  BehaviourData.cxx
  AbstractTestCase.cxx
  TestCaseBase.cxx
  AbstractTestCaseFactory.cxx
  InputFileGeneratorFactory.cxx
  TestCaseParameters.cxx
  UniaxialTensileTest.cxx
  ClosedPipeTest.cxx
  MTestInputFileGenerators.cxx
  LicosInputFileGenerators.cxx
  MFMTestGeneratorFileExport.cxx)
target_include_directories(MFMTestGenerator
  PUBLIC 
  $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/include>
  $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/mfront/include>
  $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/mfront/include>
  $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/mfm-test-generator/include>
  $<INSTALL_INTERFACE:include>)
target_link_libraries(MFMTestGenerator
  PUBLIC
  MFrontLogStream
  TFELMTest TFELMaterial
  TFELSystem TFELUtilities)
if(enable-static)
  target_include_directories(MFMTestGenerator-static
   PUBLIC 
   $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/include>
   $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/mfront/include>
   $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/mfront/include>
   $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/mfm-test-generator/include>
   $<INSTALL_INTERFACE:include>)
  target_link_libraries(MFMTestGenerator-static
    PUBLIC
    MFrontLogStream-static
    TFELMTest-static TFELMaterial-static
    TFELSystem-static TFELUtilities-static)
endif(enable-static)

if(TFEL_HAVE_MADNEX)
  target_compile_definitions(MFMTestGenerator
    PUBLIC MFM_TEST_GENERATOR_HAVE_MADNEX)
  target_link_libraries(MFMTestGenerator
    PUBLIC madnex::Madnex)
  if(enable-static)
    target_compile_definitions(MFMTestGenerator-static
      PUBLIC MFM_TEST_GENERATOR_HAVE_MADNEX)
    target_link_libraries(MFMTestGenerator-static
      PUBLIC madnex::Madnex)
  endif(enable-static)
endif(TFEL_HAVE_MADNEX)

add_executable(mfm-test-generator mfm-test-generator.cxx)
set_property(TARGET mfm-test-generator PROPERTY POSITION_INDEPENDENT_CODE TRUE)
target_link_libraries(mfm-test-generator
 PRIVATE
 MFMTestGenerator)
if(TFEL_APPEND_SUFFIX)
  set_target_properties(mfm-test-generator
    PROPERTIES OUTPUT_NAME "mfm-test-generator-${TFEL_SUFFIX}")
endif(TFEL_APPEND_SUFFIX)
install(TARGETS mfm-test-generator DESTINATION bin COMPONENT mfm)

=== mfm/src/CMakeLists.txt ===
add_executable(mfm mfm.cxx)
target_link_libraries(mfm
  TFELSystem TFELUtilities)
set_property(TARGET mfm PROPERTY POSITION_INDEPENDENT_CODE TRUE)
if(TFEL_APPEND_SUFFIX)
  set_target_properties(mfm
    PROPERTIES OUTPUT_NAME "mfm-${TFEL_SUFFIX}")
endif(TFEL_APPEND_SUFFIX)
install(TARGETS mfm DESTINATION bin COMPONENT mfm)

=== mfm/tests/CMakeLists.txt ===
macro(mfm_test args mfront_library file)
  if(NOT MFM_TEST_ID)
    set(MFM_TEST_ID 0)
  endif(NOT MFM_TEST_ID)
  if(CMAKE_CONFIGURATION_TYPES)
    foreach(conf ${CMAKE_CONFIGURATION_TYPES})
      set(test "mfm-test-${MFM_TEST_ID}_${conf}")
      add_test(NAME ${test}
	COMMAND ${CMAKE_COMMAND}
	-D TEST_PROGRAM=$<TARGET_FILE:mfm>
	-D TEST_ARGS=${args}
	-D LIBRARY=${mfront_library}
	-D TEST_OUTPUT=mfm-result-${MFM_TEST_ID}.txt
	-D REFERENCE_FILE=${CMAKE_CURRENT_SOURCE_DIR}/references/${file}
	-P ${CMAKE_CURRENT_SOURCE_DIR}/mfm.cmake
	CONFIGURATIONS ${conf})
	if((CMAKE_HOST_WIN32) AND (NOT MSYS))
          set_property(TEST ${test}
            PROPERTY DEPENDS "mfm"
	    PROPERTY ENVIRONMENT "PATH=$<TARGET_FILE_DIR:TFELMTest>\;$<TARGET_FILE_DIR:TFELMFront>\;$<TARGET_FILE_DIR:MFrontLogStream>\;$<TARGET_FILE_DIR:TFELMaterial>\;$<TARGET_FILE_DIR:TFELNUMODIS>\;$<TARGET_FILE_DIR:TFELMathParser>\;$<TARGET_FILE_DIR:TFELGlossary>\;$<TARGET_FILE_DIR:TFELSystem>\;$<TARGET_FILE_DIR:TFELUtilities>\;$<TARGET_FILE_DIR:TFELException>\;$<TARGET_FILE_DIR:TFELTests>\;$<TARGET_FILE_DIR:TFELConfig>\;$ENV{PATH}")
	elseif((CMAKE_HOST_WIN32) AND (NOT MSYS))
          set_property(TEST ${test}
            PROPERTY DEPENDS "mfm")
	endif((CMAKE_HOST_WIN32) AND (NOT MSYS))
    endforeach(conf ${CMAKE_CONFIGURATION_TYPES})
  else(CMAKE_CONFIGURATION_TYPES)
    set(test "mfm-test-${MFM_TEST_ID}")
    add_test(NAME ${test}
      COMMAND ${CMAKE_COMMAND}
      -D TEST_PROGRAM=$<TARGET_FILE:mfm>
      -D TEST_ARGS=${args}
      -D LIBRARY=${mfront_library}
      -D TEST_OUTPUT=mfm-result-${MFM_TEST_ID}.txt
      -D REFERENCE_FILE=${CMAKE_CURRENT_SOURCE_DIR}/references/${file}
      -P ${CMAKE_CURRENT_SOURCE_DIR}/mfm.cmake )
    set_property(TEST ${test} PROPERTY DEPENDS "mfm")
  endif(CMAKE_CONFIGURATION_TYPES)
  # The previous definition with generators, which does not work !!
  #
  #   add_test(mfm-test-${MFM_TEST_ID}
  #     ${CMAKE_COMMAND}
  #     -D CONFIG=$<CONFIG>
  #     -D TEST_PROGRAM=${mfm}
  # # ${PROJECT_BINARY_DIR}/mfm/src/mfm${CMAKE_EXECUTABLE_SUFFIX}
  #     -D TEST_ARGS=${args}
  #     -D MFRONT_FILE=${CMAKE_SOURCE_DIR}/mfront/tests/behaviours/${mfront_file}
  #     -D TEST_OUTPUT=mfm-result-${MFM_TEST_ID}.txt
  #     -D REFERENCE_FILE=${CMAKE_CURRENT_SOURCE_DIR}/references/${file}
  #     -P ${CMAKE_CURRENT_SOURCE_DIR}/mfm.cmake )
  MATH(EXPR MFM_TEST_ID "${MFM_TEST_ID}+1")
endmacro(mfm_test)

if(HAVE_CASTEM)
mfm_test("--filter-by-name=.+t91.+" $<TARGET_FILE:MFrontCastemBehaviours>
  "mfm-t91.ref")
endif(HAVE_CASTEM)
# mfm_test("--state-variables" "Norton.mfront"
#   "mfm-norton-material-properites.ref")

=== PKGBUILD ===
# Maintainer: Rafał Brzegowy <rafal.brzegowy@yahoo.com>

_realname=tfel
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=4.2.1
pkgrel=1
pkgdesc='MFront: a code generation tool dedicated to material knowledge (mingw-w64)'
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
provides=("${MINGW_PACKAGE_PREFIX}-mfront")
depends=("${MINGW_PACKAGE_PREFIX}-gnuplot"
         $([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]] || echo "${MINGW_PACKAGE_PREFIX}-gcc-libgfortran") )
makedepends=("unzip"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-cc"
             $([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]] || echo "${MINGW_PACKAGE_PREFIX}-gcc-fortran") )
license=('spdx:GPL-3.0-or-later')
url='https://tfel.sourceforge.io/'
source=(https://github.com/thelfer/${_realname}/archive/TFEL-${pkgver}.zip)
sha256sums=('6f3369bf22a891d713beff3d87f4d6960d88f6dd3ed5d4830befae7296f387b7')
noextract=("TFEL-${pkgver}.zip") # bsdtar could not unpack this archive

prepare() {
  unzip -oq TFEL-${pkgver}.zip -d ${srcdir}
}

build() {
  [[ -d "${srcdir}/build-${MSYSTEM}" ]] && rm -rf "${srcdir}/build-${MSYSTEM}"
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  declare -a extra_conf
  case ${MSYSTEM} in
    CLANG*)
      extra_conf+=("-Denable-fortran=OFF");;
    *)
      extra_conf+=("-Denable-fortran=ON");;
  esac

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    ${MINGW_PREFIX}/bin/cmake \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      -DCMAKE_BUILD_TYPE=Release \
      -Denable-python=OFF \
      -Denable-python-bindings=OFF \
      -Denable-aster=ON \
      -Denable-abaqus=ON \
      -Denable-ansys=ON \
      -Denable-europlexus=ON \
      -Denable-zmat=ON \
      -Denable-cyrano=ON \
      -Denable-calculix=ON \
      -Denable-comsol=ON \
      -Denable-diana-fea=ON \
      -Denable-lsdyna=ON \
      -Denable-cxx-17=ON \
      -Denable-portable-build=ON \
      -Denable-reference-doc=OFF \
      ${extra_conf} \
      ../${_realname}-TFEL-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"
  DESTDIR=${pkgdir} cmake --build . --target install
  install -Dm644 ${srcdir}/${_realname}-TFEL-${pkgver}/LICENCE-GNU-GPL ${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
}

# vim: ts=2 sw=2 et:
